Index: trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4LundStringFragmentation.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4LundStringFragmentation.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4LundStringFragmentation.cc	(revision 962)
@@ -318,277 +619,66 @@
         HadronPt.setZ(0.5* string->GetDecayDirection() *
 			(z * string->LightConeDecay() - 
-			 HadronMass2T/(z * string->LightConeDecay())));
+			 HadronMassT2/(z * string->LightConeDecay())));
 
         G4double HadronE  = 0.5* (z * string->LightConeDecay() + 
-				  HadronMass2T/(z * string->LightConeDecay()));
+				  HadronMassT2/(z * string->LightConeDecay()));
 
        G4LorentzVector * a4Momentum= new G4LorentzVector(HadronPt,HadronE);
 
-//G4cout<<"Out of SplitEandP Pz E "<<HadronPt.getZ()<<" "<<0.5* (z * string->LightConeDecay() + HadronMass2T/(z * string->LightConeDecay()))<<G4endl;
+//G4cout<<"Hadron Pt"<<HadronPt<<G4endl;
+//G4cout<<"Out of SplitEandP Pz E "<<HadronPt.getZ()<<" "<<HadronE<<G4endl;
 
        return a4Momentum;
 }
 
-
 //-----------------------------------------------------------------------------------------
-
-G4bool G4LundStringFragmentation::SplitLast(G4FragmentingString * string,
-					     G4KineticTrackVector * LeftVector,
-    					     G4KineticTrackVector * RightVector)
+G4double G4LundStringFragmentation::GetLightConeZ(G4double zmin, G4double zmax, 
+                                                  G4int PDGEncodingOfDecayParton,
+                                                  G4ParticleDefinition* pHadron,
+                                                  G4double Px, G4double Py)
 {
-    //... perform last cluster decay
-//G4cout<<"SplitLast String mass "<<string->Mass()<<G4endl;
-//G4cout<<string->GetLeftParton()->GetPDGEncoding()<<" "<<G4endl;
-//G4cout<<string->GetRightParton()->GetPDGEncoding()<<" "<<G4endl;
-
-    G4ThreeVector ClusterVel =string->Get4Momentum().boostVector();
-
-    G4double ResidualMass   = string->Mass(); 
-//    G4double ClusterMassCut = ClusterMass;
-
-    G4int cClusterInterrupt = 0;
-
-    G4ParticleDefinition * LeftHadron, * RightHadron;
-    do
-    {
-//G4cout<<" Cicle "<<cClusterInterrupt<<" "<< ClusterLoopInterrupt<<G4endl;
-
-        if (cClusterInterrupt++ >= ClusterLoopInterrupt)
-        {
-          return false;
-        }
-	G4ParticleDefinition * quark = NULL;
-	string->SetLeftPartonStable(); // to query quark contents..
-
-	if (string->DecayIsQuark() && string->StableIsQuark() ) 
-	{
-	   //... there are quarks on cluster ends
-		LeftHadron= QuarkSplitup(string->GetLeftParton(), quark);
-	} else {
-	   //... there is a Diquark on cluster ends
-		G4int IsParticle;
-
-		if ( string->StableIsQuark() ) {
-		  IsParticle=(string->GetLeftParton()->GetPDGEncoding()>0) ? -1 : +1; 
-		} else {
-		  IsParticle=(string->GetLeftParton()->GetPDGEncoding()>0) ? +1 : -1;
-		}
-
-      		pDefPair QuarkPair = CreatePartonPair(IsParticle,false);  // no diquarks wanted
-      		quark = QuarkPair.second;
-
-      		LeftHadron=hadronizer->Build(QuarkPair.first, string->GetLeftParton());
-	}
-
-        RightHadron = hadronizer->Build(string->GetRightParton(), quark);
-
-//G4cout<<"SplitLast Left Right hadrons "<<LeftHadron->GetPDGEncoding()<<" "<<RightHadron->GetPDGEncoding()<<G4endl;
-//G4cout<<"SplitLast Left Right hadrons "<<LeftHadron->GetPDGMass()<<" "<<RightHadron->GetPDGMass()<<G4endl;
-//G4cout<<" Sum H mass Str Mass "<<LeftHadron->GetPDGMass() + RightHadron->GetPDGMass()<<" "<<ResidualMass<<G4endl;
-
-       //... repeat procedure, if mass of cluster is too low to produce hadrons
-       //... ClusterMassCut = 0.15*GeV model parameter
-//	if ( quark->GetParticleSubType()== "quark" ) {ClusterMassCut = 0.;}        // Uzhi
-//	else {ClusterMassCut = ClusterMass;}                                       // Uzhi
-
-    } 
-    while (ResidualMass <= LeftHadron->GetPDGMass() + RightHadron->GetPDGMass());         // Uzhi   VOVA
-//    while (ResidualMass <= LeftHadron->GetPDGMass() + RightHadron->GetPDGMass()  + ClusterMassCut); // Uzhi
-    //... compute hadron momenta and energies   
-
-    G4LorentzVector  LeftMom, RightMom;
-    G4ThreeVector    Pos;
-
-//G4cout<<"Sample4Momentum"<<G4endl;
-
-    Sample4Momentum(&LeftMom, LeftHadron->GetPDGMass(), &RightMom, RightHadron->GetPDGMass(), ResidualMass);
-
-    LeftMom.boost(ClusterVel);
-    RightMom.boost(ClusterVel);
-
-    LeftVector->push_back(new G4KineticTrack(LeftHadron, 0, Pos, LeftMom));
-    RightVector->push_back(new G4KineticTrack(RightHadron, 0, Pos, RightMom));
-
-    return true;
-
-}
-//----------------------------------------------------------------------------------------------------------
-
-G4bool G4LundStringFragmentation::IsFragmentable(const G4FragmentingString * const string)
-{
-//G4cout<<"In IsFragmentable"<<G4endl;
-  SetMinimalStringMass(string);                                                            // Uzhi
-//G4cout<<"Out IsFragmentable MinMass"<<MinimalStringMass<<" String Mass"<<std::sqrt(string->Get4Momentum().mag2())<<G4endl; 
-  return sqr(MinimalStringMass + WminLUND) < string->Get4Momentum().mag2();                // Uzhi
-
-//	return sqr(FragmentationMass(string)+MassCut) <                                    // Uzhi
-//			string->Mass2();                                                   // Uzhi
-}
-
-//----------------------------------------------------------------------------------------------------------
-
-G4bool G4LundStringFragmentation::StopFragmenting(const G4FragmentingString * const string)
-{
-//G4cout<<"StopFragmenting"<<G4endl;
-
-  SetMinimalStringMass(string);                                                            // Uzhi
-//G4cout<<"StopFragm MinMass "<<MinimalStringMass<<" String Mass "<<std::sqrt(string->Get4Momentum().mag2())<<G4endl; 
-  return sqr((MinimalStringMass + WminLUND)*(1 + SmoothParam * (1.-2*G4UniformRand()))) >        // Uzhi
-                   string->Get4Momentum().mag2();                                          // Uzhi
-//       sqr(FragmentationMass(string,&G4HadronBuilder::BuildHighSpin)+MassCut) >          // Uzhi
-//       string->Get4Momentum().mag2();                                                    // Uzhi
-}
-
-//----------------------------------------------------------------------------------------------------------
-
-void G4LundStringFragmentation::Sample4Momentum(G4LorentzVector* Mom, G4double Mass, G4LorentzVector* AntiMom, G4double AntiMass, G4double InitialMass) 
-    {
-     G4ThreeVector Pt;                                                      // Uzhi
-     G4double MassMt2, AntiMassMt2;                                         // Uzhi
-     G4double AvailablePz, AvailablePz2;                                    // Uzhi
-
-//G4cout<<" Smpl4Mom "<<Mass<<" "<<AntiMass<<" "<<InitialMass<<G4endl; 
-                                                                            // Uzhi
-    do                                                                      // Uzhi
-      {                                                                     // Uzhi
-       Pt=SampleQuarkPt(); Pt.setZ(0); G4double Pt2=Pt.mag2();              // Uzhi
-
-//G4cout<<"Sample4Momentum Pt x y "<<Pt.getX()<<" "<<Pt.getY()<<G4endl;
-
-       MassMt2    =     Mass *     Mass + Pt2;                              // Uzhi
-       AntiMassMt2= AntiMass * AntiMass + Pt2;                              // Uzhi
-
-//G4cout<<"Mts "<<MassMt2<<" "<<AntiMassMt2<<" "<<InitialMass*InitialMass<<G4endl;
-
-       AvailablePz2= sqr(InitialMass*InitialMass - MassMt2 - AntiMassMt2) - 
-                     4.*MassMt2*AntiMassMt2;                                // Uzhi
-      }                                                                     // Uzhi
-    while(AvailablePz2 < 0.);                                               // Uzhi
-                                                                            // Uzhi
-    AvailablePz2 /=(4.*InitialMass*InitialMass);                            // Uzhi
-                                                                            // Uzhi
-    AvailablePz = std::sqrt(AvailablePz2);                                  // Uzhi
-
-//G4cout<<"AvailablePz "<<AvailablePz<<G4endl;
- 
-
-    G4double Px=Pt.getX();                                                  // Uzhi
-    G4double Py=Pt.getY();                                                  // Uzhi
-                                                                            // Uzhi
-    Mom->setPx(Px); Mom->setPy(Py); Mom->setPz(AvailablePz);                // Uzhi
-    Mom->setE(std::sqrt(MassMt2+AvailablePz2));                             // Uzhi
-
-//G4cout<<" 1 part "<<Px<<"  "<<Py<<" "<<AvailablePz<<" "<<std::sqrt(MassMt2+AvailablePz2)<<G4endl;
-
-                                                                            // Uzhi
-    AntiMom->setPx(-Px); AntiMom->setPy(-Py); AntiMom->setPz(-AvailablePz); // Uzhi
-    AntiMom->setE (std::sqrt(AntiMassMt2+AvailablePz2));                    // Uzhi
-
-//G4cout<<" 2 part "<<-Px<<"  "<<-Py<<" "<<-AvailablePz<<" "<<std::sqrt(AntiMassMt2+AvailablePz2)<<G4endl;
-
-// Maybe it must be inversed!                                               // Uzhi
-/*                                                                          // Uzhi
-    G4double r_val = sqr(InitialMass*InitialMass - Mass*Mass - AntiMass*AntiMass) - sqr(2.*Mass*AntiMass);
-    G4double Pabs = (r_val > 0.)? std::sqrt(r_val)/(2.*InitialMass) : 0;
-
-    //... sample unit vector       
-    G4double pz = 1. - 2.*G4UniformRand();  
-    G4double st     = std::sqrt(1. - pz * pz)*Pabs;
-    G4double phi    = 2.*pi*G4UniformRand();
-    G4double px = st*std::cos(phi);
-    G4double py = st*std::sin(phi);
-    pz *= Pabs;
+    G4double  alund;                
+
+//    If blund get restored, you MUST adapt the calculation of zOfMaxyf.
+//    const G4double  blund = 1;
+
+    G4double z, yf;
+    G4double Mass = pHadron->GetPDGMass();
+//  G4int HadronEncoding=pHadron->GetPDGEncoding();
     
-    Mom->setPx(px); Mom->setPy(py); Mom->setPz(pz);
-    Mom->setE(std::sqrt(Pabs*Pabs + Mass*Mass));
-
-    AntiMom->setPx(-px); AntiMom->setPy(-py); AntiMom->setPz(-pz);
-    AntiMom->setE (std::sqrt(Pabs*Pabs + AntiMass*AntiMass));
-*/                                                                           // Uzhi
+    G4double Mt2 = Px*Px + Py*Py + Mass*Mass;
+
+    if(std::abs(PDGEncodingOfDecayParton) < 1000)            
+    {                                                          
+    // ---------------- Quark fragmentation ----------------------
+       alund=0.35/GeV/GeV; // Instead of 0.7 because kinks are not considered
+       G4double zOfMaxyf=alund*Mt2/(alund*Mt2 + 1.);
+       G4double maxYf=(1-zOfMaxyf)/zOfMaxyf * std::exp(-alund*Mt2/zOfMaxyf);
+
+       do                                                        
+         {
+          z = zmin + G4UniformRand()*(zmax-zmin);
+//        yf = std::pow(1. - z, blund)/z*std::exp(-alund*Mt2/z);
+	  yf = (1-z)/z * std::exp(-alund*Mt2/z);
+         } 
+       while (G4UniformRand()*maxYf > yf); 
+    }                                                           
+    else                                                          
+    {                                                           
+     // ---------------- Di-quark fragmentation ----------------------
+//G4cout<<"Di-quark"<<G4endl; // Vova
+       alund=0.7/GeV/GeV;    // 0.7 2.0
+       G4double zOfMaxyf=alund*Mt2/(alund*Mt2 + 1.);
+       G4double maxYf=(1-zOfMaxyf)/zOfMaxyf * std::exp(-alund*Mt2/zOfMaxyf);
+       do                                                         
+         {
+          z = zmin + G4UniformRand()*(zmax-zmin);
+//        yf = std::pow(1. - z, blund)/z*std::exp(-alund*Mt2/z);
+	  yf = (1-z)/z * std::exp(-alund*Mt2/z);
+         } 
+       while (G4UniformRand()*maxYf > yf); 
+    };                                                           
+
+//G4cout<<" test z "<<std::pow(2.,3.)<<" "<<z<<G4endl;
+    return z;
     }
-
-
-void G4LundStringFragmentation::SetMinimalStringMass(const G4FragmentingString  * const string)  // Uzhi
-{
-//G4cout<<"In SetMinMass -------------------"<<std::sqrt(string->Mass2())<<G4endl;
-//G4cout<<string->GetLeftParton()->GetPDGEncoding()<<G4endl;
-//G4cout<<string->GetRightParton()->GetPDGEncoding()<<G4endl;
-
-  G4double EstimatedMass=0.750* GeV;  // 2*m_q
-
-  G4int Qleft =std::abs(string->GetLeftParton()->GetPDGEncoding());
-
-  if( Qleft > 1000) 
-    {
-     G4int q1=Qleft/1000;
-     if( q1 < 3) {EstimatedMass += 0.325* GeV;}
-     if( q1 > 2) {EstimatedMass += 0.500* GeV;}     
-
-     G4int q2=(Qleft/100)%10;
-     if( q2 < 3) {EstimatedMass += 0.325* GeV;}
-     if( q2 > 2) {EstimatedMass += 0.500* GeV;} 
-    }
-  else
-    {
-     if( Qleft < 3) {EstimatedMass += 0.325* GeV;}
-     if( Qleft > 2) {EstimatedMass += 0.500* GeV;} 
-    }
-
-  G4int Qright=std::abs(string->GetRightParton()->GetPDGEncoding());
-
-  if( Qright > 1000) 
-    {
-     G4int q1=Qright/1000;
-     if( q1 < 3) {EstimatedMass += 0.325* GeV;}
-     if( q1 > 2) {EstimatedMass += 0.500* GeV;}     
-
-     G4int q2=(Qright/100)%10;
-     if( q2 < 3) {EstimatedMass += 0.325* GeV;}
-     if( q2 > 2) {EstimatedMass += 0.500* GeV;} 
-    }
-  else
-    {
-     if( Qright < 3) {EstimatedMass += 0.325* GeV;}
-     if( Qright > 2) {EstimatedMass += 0.500* GeV;} 
-    }
-
-  MinimalStringMass=EstimatedMass;
-  SetMinimalStringMass2(EstimatedMass);
-
-/*
-  Pcreate build=&G4HadronBuilder::BuildLowSpin;
-
-  G4ParticleDefinition *Hadron1, *Hadron2=0;
-
-  G4int iflc = (G4UniformRand() < 0.5)? 1 : 2;
-
-  if (string->GetLeftParton()->GetParticleSubType() == "quark") iflc = -iflc;
-
-  if (string->GetLeftParton()->GetPDGEncoding() < 0) iflc = -iflc;
-
-  // 1/2 baryon (anti-baryon) and scalar meson     (QQ-q or QbarQbar-Qbar),
-  // or 2 scalar mesons                            (Q-Qbar),
-  // or 2 1/2 baryons (anti-baryons) will be built (QQ-QbarQbar)
-
-//G4cout<<"In SetMinMass -------------------"<<std::sqrt(string->Mass2())<<G4endl;
-//G4cout<<string->GetLeftParton()->GetPDGEncoding()<<" "<<FindParticle(iflc)->GetPDGEncoding()<<G4endl;
-//G4cout<<string->GetRightParton()->GetPDGEncoding()<<" "<<FindParticle(-iflc)->GetPDGEncoding()<<G4endl;
-
-  Hadron1 = (hadronizer->*build)(string->GetLeftParton(),FindParticle(iflc));
-  Hadron2 =(hadronizer->*build)(string->GetRightParton(),FindParticle(-iflc));
-  MinimalStringMass = (Hadron1)->GetPDGMass() + (Hadron2)->GetPDGMass();
-
-//G4cout<<(Hadron1)->GetPDGEncoding()<<" "<<(Hadron2)->GetPDGEncoding()<<G4endl;
-//G4cout<<"Out SetMinMass "<<MinimalStringMass<<G4endl;
-*/
-//  SetMinimalStringMass2(MinimalStringMass);
-}
-//*******************************************************************************************************
-
-void G4LundStringFragmentation::SetMinimalStringMass2(const G4double aValue)                     // Uzhi
-{
-  MinimalStringMass2=aValue * aValue;
-}
-//*******************************************************************************************************
-
-//****************************************************************************************
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4QGSMFragmentation.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4QGSMFragmentation.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4QGSMFragmentation.cc	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QGSMFragmentation.cc,v 1.6 2007/04/24 14:55:23 gunter Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: G4QGSMFragmentation.cc,v 1.9 2008/06/23 08:35:55 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // -----------------------------------------------------------------------------
@@ -121,5 +121,5 @@
 			} else {
 			 // abandon ... start from the beginning
-			   if (newString) delete newString;
+			   if (newString) delete newString;          // Uzhi restore 20.06.08
 			   if (Hadron)    delete Hadron;
 			   inner_sucess=false;
@@ -229,5 +229,6 @@
 
 G4LorentzVector * G4QGSMFragmentation::SplitEandP(G4ParticleDefinition * pHadron,
-	G4FragmentingString * string)
+                                                  G4FragmentingString * string,    // Uzhi
+                                                  G4FragmentingString * ) // Uzhi
 {
        G4double HadronMass = pHadron->GetPDGMass();
Index: trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4VKinkyStringDecay.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4VKinkyStringDecay.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/hadronization/src/G4VKinkyStringDecay.cc	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VKinkyStringDecay.cc,v 1.3 2006/06/29 20:55:07 gunter Exp $
-// GEANT4 tag $Name:  $
+// $Id: G4VKinkyStringDecay.cc,v 1.4 2008/04/25 14:20:14 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //  Maxim Komogorov
 //
